# _*_ coding: iso-8859-1 _*_
# Change les ACLs d'un fichier/dossier (non rcursivement, TODO utiliser "AddAccessAllowedAceEx" pour a)
import win32security as wsec
import win32file as wf
import win32api as wa
import ntsecuritycon as ntsec

def AdjustPrivilege(privileges):
    """Active les privilges lists dans privileges
    """
    for priv in privileges:
        # Get the process token.
        flags = ntsec.TOKEN_ADJUST_PRIVILEGES | ntsec.TOKEN_QUERY
        htoken = wsec.OpenProcessToken(wa.GetCurrentProcess(), flags)
        # Get the ID for the privilege.
        id = wsec.LookupPrivilegeValue(None, priv)
        # Now obtain the privilege for this process.
        newPrivileges = [(id, ntsec.SE_PRIVILEGE_ENABLED)]
        # and make the adjustment.
        wsec.AdjustTokenPrivileges(htoken, 0, newPrivileges)

def set_acl(obj, domain=None):
    """Met l'ACL "contrle total" sur obj
    non rcursivement
    """
    # Le SID de DomainUsers
    if domain: dusers = r'%s\DomainUsers'%domain
    else: dusers = 'DomainUsers'
    domainusers_sid = wsec.LookupAccountName('',dusers)[0]
    # rcupration du descripteur (vive le franais) de scu
    info = wsec.DACL_SECURITY_INFORMATION
    sd = wsec.GetFileSecurity(obj, info)
    # les ACLs
    acl = sd.GetSecurityDescriptorDacl()
    # ajout de l'ACL Accs complet pour DomainUSers
    acl.AddAccessAllowedAceEx(wsec.ACL_REVISION_DS, wsec.OBJECT_INHERIT_ACE, wf.FILE_ALL_ACCESS, domainusers_sid)
    # maj du Security Descriptor
    sd.SetSecurityDescriptorDacl(1, acl, 0)
    # application sur l'objet
    wsec.SetFileSecurity(obj, info, sd)

