#!/usr/bin/env python
# _*_ coding: iso-8859-15 _*_



import win32serviceutil as wsu
import win32service as ws
import win32api as wa
import socket
import os

import process
import lance_cmd

input_template="""Windows Registry Editor Version 5.00

[HKEY_LOCAL_MACHINE\SOFTWARE\ORL\WinVNC3\Default]
"InputsEnabled"=dword:0000000%s

"""


class Vnc:
    """Gestion vnc distante. Actions possibles :
            - start  - restart  - start_listen  - connect (ip)
            - stop              - stop_listen   - disconnect
            - setinputs True/False (gestion clavier/souris)
    """
    def __init__(self, vncdir, tmpdir):
        self.vncdir = vncdir
        self.tmpdir = tmpdir
        self.vnc_conf = os.path.join(self.vncdir, 'eole_conf.vnc')
        self.sname = 'winvnc'
        self.winvnc_exe = os.path.join(self.vncdir, 'winvnc.exe')
        self.vncviewer = os.path.join(self.vncdir, 'vncviewer.exe')
        
    def start(self):
        if not self.isrunning():
            lance_cmd.lancecmd('net start %s'%self.sname, hide=True)
            wa.WinExec('%s -servicehelper'%self.winvnc_exe)

    def stop(self):
        if self.isrunning():
            lance_cmd.lancecmd('net stop %s'%self.sname, hide=True)
    
    def restart(self):
        self.stop()
        self.start()
        
    def isrunning(self):
        return process.isrunning('winvnc.exe')
##        if wsu.QueryServiceStatus(self.sname)[1] == ws.SERVICE_RUNNING:
##            return True
##        return False
    
    def setinputs(self, val=False):
        """(ds)activer souris/clavier (activ par dfaut)
        """
        if val: t = input_template%1
        else: t = input_template%0
        fich = os.path.join(self.tmpdir, 'vnc_inputs.reg')
        file(fich, 'w').write(t)
        lance_cmd.lancecmd('regedit /s %s'%fich, hide=True)
        if self.isrunning():
            self.restart()
        os.remove(fich)
        
    def start_listen(self, val=None, conf=None):
        """se mettre en mode listen
        """
        if conf: file(self.vnc_conf, 'w').write(conf)
        if not self.is_listening():
            if not val: val = ''
            cmd = '%s %s /config %s /listen'%(self.vncviewer, val, self.vnc_conf)
            lance_cmd.lancecmd(cmd, nowait=True)
        
    def stop_listen(self):
        """kill self.listen_pid"""
        process.killProcName('vncviewer.exe')
    
    def is_listening(self):
        try:
            s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            s.settimeout(1)
            s.connect(('127.0.0.1', int(5400)))
            s.close()
            return True
        except:
            return False

    def connect(self, ip):
        """connecter une ip qui est en mode "listen"
        """
        self.start()
        wa.WinExec('%s -connect %s'%(self.winvnc_exe, ip))
    
    def disconnect(self):
        """redmarrer le service VNC dconnecte
        """
        self.restart()

